scripts/functions
author "Yann E. MORIN" <yann.morin.1998@anciens.enib.fr>
Mon May 28 21:33:35 2007 +0000 (2007-05-28)
changeset 143 420f814f1871
parent 136 22b5ef41df97
child 145 1761c8b3f415
permissions -rw-r--r--
Fix and enhance the STOP/RESTART facility.
     1 # This file contains some usefull common functions
     2 # Copyright 2007 Yann E. MORIN
     3 # Licensed under the GPL v2. See COPYING in the root of this package
     4 
     5 # Prepare the fault handler
     6 CT_OnError() {
     7     ret=$?
     8     CT_DoLog ERROR "Build failed in step \"${CT_STEP_MESSAGE[${CT_STEP_COUNT}]}\""
     9     for((step=(CT_STEP_COUNT-1); step>1; step--)); do
    10         CT_DoLog ERROR "      called in step \"${CT_STEP_MESSAGE[${step}]}\""
    11     done
    12     CT_DoLog ERROR "Error happened in \"${BASH_SOURCE[1]}\" in function \"${FUNCNAME[1]}\" (line unknown, sorry)"
    13     for((depth=2; ${BASH_LINENO[$((${depth}-1))]}>0; depth++)); do
    14         CT_DoLog ERROR "      called from \"${BASH_SOURCE[${depth}]}\" at line # ${BASH_LINENO[${depth}-1]} in function \"${FUNCNAME[${depth}]}\""
    15     done
    16     [ "${CT_LOG_TO_FILE}" = "y" ] && CT_DoLog ERROR "Look at \"${CT_LOG_FILE}\" for more info on this error."
    17     CT_STEP_COUNT=1
    18     CT_DoEnd ERROR
    19     exit $ret
    20 }
    21 
    22 # Install the fault handler
    23 trap CT_OnError ERR
    24 
    25 # Inherit the fault handler in subshells and functions
    26 set -E
    27 
    28 # Make pipes fail on the _first_ failed command
    29 # Not supported on bash < 3.x, but we need it, so drop the obsoleting bash-2.x
    30 set -o pipefail
    31 
    32 # Don't hash commands' locations, and search every time it is requested.
    33 # This is slow, but needed because of the static/shared core gcc which shall
    34 # always match to shared if it exists, and only fallback to static if the
    35 # shared is not found
    36 set +o hashall
    37 
    38 # The different log levels:
    39 CT_LOG_LEVEL_ERROR=0
    40 CT_LOG_LEVEL_WARN=1
    41 CT_LOG_LEVEL_INFO=2
    42 CT_LOG_LEVEL_EXTRA=3
    43 CT_LOG_LEVEL_DEBUG=4
    44 CT_LOG_LEVEL_ALL=5
    45 
    46 # A function to log what is happening
    47 # Different log level are available:
    48 #   - ERROR:   A serious, fatal error occurred
    49 #   - WARN:    A non fatal, non serious error occurred, take your responsbility with the generated build
    50 #   - INFO:    Informational messages
    51 #   - EXTRA:   Extra informational messages
    52 #   - DEBUG:   Debug messages
    53 #   - ALL:     Component's build messages
    54 # Usage: CT_DoLog <level> [message]
    55 # If message is empty, then stdin will be logged.
    56 CT_DoLog() {
    57     local max_level LEVEL level cur_l cur_L
    58     local l
    59     eval max_level="\${CT_LOG_LEVEL_${CT_LOG_LEVEL_MAX}}"
    60     # Set the maximum log level to DEBUG if we have none
    61     [ -z "${max_level}" ] && max_level=${CT_LOG_LEVEL_DEBUG}
    62 
    63     LEVEL="$1"; shift
    64     eval level="\${CT_LOG_LEVEL_${LEVEL}}"
    65 
    66     if [ $# -eq 0 ]; then
    67         cat -
    68     else
    69         echo "${1}"
    70     fi |( IFS="\n" # We want the full lines, even leading spaces
    71           CT_PROG_BAR_CPT=0
    72           indent=$((2*CT_STEP_COUNT))
    73           while read line; do
    74               case "${CT_LOG_SEE_TOOLS_WARN},${line}" in
    75                 y,*"warning:"*)         cur_L=WARN; cur_l=${CT_LOG_LEVEL_WARN};;
    76                 y,*"WARNING:"*)         cur_L=WARN; cur_l=${CT_LOG_LEVEL_WARN};;
    77                 *"error:"*)             cur_L=ERROR; cur_l=${CT_LOG_LEVEL_ERROR};;
    78                 *"make["?*"]:"*"Stop.") cur_L=ERROR; cur_l=${CT_LOG_LEVEL_ERROR};;
    79                 *)                      cur_L="${LEVEL}"; cur_l="${level}";;
    80               esac
    81               l="`printf \"[%-5s]%*s%s%s\" \"${cur_L}\" \"${indent}\" \" \" \"${line}\"`"
    82               # There will always be a log file, be it /dev/null
    83               echo -e "${l}"
    84               if [ ${cur_l} -le ${max_level} ]; then
    85                   echo -e "\r${l}" >&6
    86               fi
    87               if [ "${CT_LOG_PROGRESS_BAR}" = "y" ]; then
    88                   [ ${CT_PROG_BAR_CPT} -eq 0  ] && bar="/"
    89                   [ ${CT_PROG_BAR_CPT} -eq 10 ] && bar="-"
    90                   [ ${CT_PROG_BAR_CPT} -eq 20 ] && bar="\\"
    91                   [ ${CT_PROG_BAR_CPT} -eq 30 ] && bar="|"
    92                   printf "\r[%02d:%02d] %s " $((SECONDS/60)) $((SECONDS%60)) "${bar}" >&6
    93                   CT_PROG_BAR_CPT=$(((CT_PROG_BAR_CPT+1)%40))
    94               fi
    95           done
    96         )
    97 
    98     return 0
    99 }
   100 
   101 # Tail message to be logged whatever happens
   102 # Usage: CT_DoEnd <level>
   103 CT_DoEnd()
   104 {
   105     CT_STOP_DATE=`CT_DoDate +%s%N`
   106     CT_STOP_DATE_HUMAN=`CT_DoDate +%Y%m%d.%H%M%S`
   107     CT_DoLog INFO "Build completed at ${CT_STOP_DATE_HUMAN}"
   108     elapsed=$((CT_STOP_DATE-CT_STAR_DATE))
   109     elapsed_min=$((elapsed/(60*1000*1000*1000)))
   110     elapsed_sec=`printf "%02d" $(((elapsed%(60*1000*1000*1000))/(1000*1000*1000)))`
   111     elapsed_csec=`printf "%02d" $(((elapsed%(1000*1000*1000))/(10*1000*1000)))`
   112     CT_DoLog ${1:-INFO} "(elapsed: ${elapsed_min}:${elapsed_sec}.${elapsed_csec})"
   113 }
   114 
   115 # Abort the execution with an error message
   116 # Usage: CT_Abort <message>
   117 CT_Abort() {
   118     CT_DoLog ERROR "$1"
   119     exit 1
   120 }
   121 
   122 # Test a condition, and print a message if satisfied
   123 # Usage: CT_Test <message> <tests>
   124 CT_Test() {
   125     local ret
   126     local m="$1"
   127     shift
   128     test "$@" && CT_DoLog WARN "$m"
   129     return 0
   130 }
   131 
   132 # Test a condition, and abort with an error message if satisfied
   133 # Usage: CT_TestAndAbort <message> <tests>
   134 CT_TestAndAbort() {
   135     local m="$1"
   136     shift
   137     test "$@" && CT_Abort "$m"
   138     return 0
   139 }
   140 
   141 # Test a condition, and abort with an error message if not satisfied
   142 # Usage: CT_TestAndAbort <message> <tests>
   143 CT_TestOrAbort() {
   144     local m="$1"
   145     shift
   146     test "$@" || CT_Abort "$m"
   147     return 0
   148 }
   149 
   150 # Test the presence of a tool, or abort if not found
   151 # Usage: CT_HasOrAbort <tool>
   152 CT_HasOrAbort() {
   153     CT_TestAndAbort "\"${1}\" not found and needed for successfull toolchain build." -z "`which \"${1}\"`"
   154     return 0
   155 }
   156 
   157 # Get current date with nanosecond precision
   158 # On those system not supporting nanosecond precision, faked with rounding down
   159 # to the highest entire second
   160 # Usage: CT_DoDate <fmt>
   161 CT_DoDate() {
   162     date "$1" |sed -r -e 's/%N$/000000000/;'
   163 }
   164 
   165 CT_STEP_COUNT=1
   166 CT_STEP_MESSAGE[${CT_STEP_COUNT}]="<none>"
   167 # Memorise a step being done so that any error is caught
   168 # Usage: CT_DoStep <loglevel> <message>
   169 CT_DoStep() {
   170     local start=`CT_DoDate +%s%N`
   171     CT_DoLog "$1" "================================================================="
   172     CT_DoLog "$1" "$2"
   173     CT_STEP_COUNT=$((CT_STEP_COUNT+1))
   174     CT_STEP_LEVEL[${CT_STEP_COUNT}]="$1"; shift
   175     CT_STEP_START[${CT_STEP_COUNT}]="${start}"
   176     CT_STEP_MESSAGE[${CT_STEP_COUNT}]="$1"
   177     return 0
   178 }
   179 
   180 # End the step just being done
   181 # Usage: CT_EndStep
   182 CT_EndStep() {
   183     local stop=`CT_DoDate +%s%N`
   184     local duration=`printf "%032d" $((stop-${CT_STEP_START[${CT_STEP_COUNT}]})) |sed -r -e 's/([[:digit:]]{2})[[:digit:]]{7}$/\.\1/; s/^0+//; s/^\./0\./;'`
   185     local level="${CT_STEP_LEVEL[${CT_STEP_COUNT}]}"
   186     local message="${CT_STEP_MESSAGE[${CT_STEP_COUNT}]}"
   187     CT_STEP_COUNT=$((CT_STEP_COUNT-1))
   188     CT_DoLog "${level}" "${message}: done in ${duration}s"
   189     return 0
   190 }
   191 
   192 # Pushes into a directory, and pops back
   193 CT_Pushd() {
   194     pushd "$1" >/dev/null 2>&1
   195 }
   196 CT_Popd() {
   197     popd >/dev/null 2>&1
   198 }
   199 
   200 # Makes a path absolute
   201 # Usage: CT_MakeAbsolutePath path
   202 CT_MakeAbsolutePath() {
   203     # Try to cd in that directory
   204     if [ -d "$1" ]; then
   205         CT_Pushd "$1"
   206         pwd
   207         CT_Popd
   208     else
   209         # No such directory, fail back to guessing
   210         case "$1" in
   211             /*)  echo "$1";;
   212             *)   echo "`pwd`/$1";;
   213         esac
   214     fi
   215     
   216     return 0
   217 }
   218 
   219 # Creates a temporary directory
   220 # $1: variable to assign to
   221 # Usage: CT_MktempDir foo
   222 CT_MktempDir() {
   223     # Some mktemp do not allow more than 6 Xs
   224     eval "$1"="`mktemp -q -d \"${CT_BUILD_DIR}/.XXXXXX\"`"
   225     CT_TestOrAbort "Could not make temporary directory" -n "${!1}" -a -d "${!1}"
   226 }
   227 
   228 # Echoes the specified string on stdout until the pipe breaks.
   229 # Doesn't fail
   230 # $1: string to echo
   231 # Usage: CT_DoYes "" |make oldconfig
   232 CT_DoYes() {
   233     yes "$1" || true
   234 }
   235 
   236 # Get the file name extension of a component
   237 # Usage: CT_GetFileExtension <component_name-component_version>
   238 # If found, echoes the extension to stdout
   239 # If not found, echoes nothing on stdout.
   240 CT_GetFileExtension() {
   241     local ext
   242     local file="$1"
   243     local got_it=1
   244 
   245     CT_Pushd "${CT_TARBALLS_DIR}"
   246     for ext in .tar.gz .tar.bz2 .tgz .tar; do
   247         if [ -f "${file}${ext}" ]; then
   248             echo "${ext}"
   249             got_it=0
   250             break
   251         fi
   252     done
   253     CT_Popd
   254 
   255     return 0
   256 }
   257 
   258 # Download an URL using wget
   259 # Usage: CT_DoGetFileWget <URL>
   260 CT_DoGetFileWget() {
   261     # Need to return true because it is legitimate to not find the tarball at
   262     # some of the provided URLs (think about snapshots, different layouts for
   263     # different gcc versions, etc...)
   264     # Some (very old!) FTP server might not support the passive mode, thus
   265     # retry without
   266     # With automated download as we are doing, it can be very dangerous to use
   267     # -c to continue the downloads. It's far better to simply overwrite the
   268     # destination file
   269     wget -nc --progress=dot:binary --tries=3 --passive-ftp "$1" || wget -nc --progress=dot:binary --tries=3 "$1" || true
   270 }
   271 
   272 # Download an URL using curl
   273 # Usage: CT_DoGetFileCurl <URL>
   274 CT_DoGetFileCurl() {
   275 	# Note: comments about wget method are also valid here
   276 	# Plus: no good progreess indicator is available with curl,
   277 	#       so output is consigned to oblivion
   278 	curl --ftp-pasv -O --retry 3 "$1" >/dev/null || curl -O --retry 3 "$1" >/dev/null || true
   279 }
   280 
   281 # Wrapper function to call one of curl or wget
   282 # Usage: CT_DoGetFile <URL>
   283 CT_DoGetFile() {
   284     local _wget=`which wget`
   285     local _curl=`which curl`
   286     case "${_wget},${_curl}" in
   287         ,)  CT_DoError "Could find neither wget nor curl";;
   288         ,*) CT_DoGetFileCurl "$1" 2>&1 |CT_DoLog DEBUG;;
   289         *)  CT_DoGetFileWget "$1" 2>&1 |CT_DoLog DEBUG;;
   290     esac
   291 }
   292 
   293 # Download the file from one of the URLs passed as argument
   294 # Usage: CT_GetFile <filename> <url> [<url> ...]
   295 CT_GetFile() {
   296     local got_it
   297     local ext
   298     local url
   299     local file="$1"
   300     shift
   301 
   302     # Do we already have it?
   303     ext=`CT_GetFileExtension "${file}"`
   304     if [ -n "${ext}" ]; then
   305         CT_DoLog DEBUG "Already have \"${file}\""
   306         return 0
   307     fi
   308 
   309     CT_Pushd "${CT_TARBALLS_DIR}"
   310     # File not yet downloaded, try to get it
   311     got_it=0
   312     # We'd rather have a bzip2'ed tarball, then gzipped, and finally plain tar.
   313     # Try local copy first, if it exists
   314     for ext in .tar.bz2 .tar.gz .tgz .tar; do
   315         if [ -r "${CT_LOCAL_TARBALLS_DIR}/${file}${ext}" -a \
   316              "${CT_FORCE_DOWNLOAD}" != "y" ]; then
   317             CT_DoLog EXTRA "Copying \"${file}\" from local copy"
   318             cp -v "${CT_LOCAL_TARBALLS_DIR}/${file}${ext}" "${file}${ext}" |CT_DoLog ALL
   319             return 0
   320         fi
   321     done
   322     # Try to download it
   323     CT_DoLog EXTRA "Retrieving \"${file}\""
   324     for ext in .tar.bz2 .tar.gz .tgz .tar; do
   325         # Try all urls in turn
   326         for url in "$@"; do
   327             case "${url}" in
   328                 *)  CT_DoLog DEBUG "Trying \"${url}/${file}${ext}\""
   329                     CT_DoGetFile "${url}/${file}${ext}"
   330                     ;;
   331             esac
   332             [ -f "${file}${ext}" ] && return 0 || true
   333         done
   334     done
   335     CT_Popd
   336 
   337     CT_Abort "Could not download \"${file}\", and not present in \"${CT_LOCAL_TARBALLS_DIR}\""
   338 }
   339 
   340 # Extract a tarball and patch the resulting sources if necessary.
   341 # Some tarballs need to be extracted in specific places. Eg.: glibc addons
   342 # must be extracted in the glibc directory; uCLibc locales must be extracted
   343 # in the extra/locale sub-directory of uClibc.
   344 CT_ExtractAndPatch() {
   345     local file="$1"
   346     local base_file=`echo "${file}" |cut -d - -f 1`
   347     local ver_file=`echo "${file}" |cut -d - -f 2-`
   348     local official_patch_dir
   349     local custom_patch_dir
   350     local libc_addon
   351     local ext=`CT_GetFileExtension "${file}"`
   352     CT_TestAndAbort "\"${file}\" not found in \"${CT_TARBALLS_DIR}\"" -z "${ext}"
   353     local full_file="${CT_TARBALLS_DIR}/${file}${ext}"
   354 
   355     CT_Pushd "${CT_SRC_DIR}"
   356 
   357     # Add-ons need a little love, really.
   358     case "${file}" in
   359         glibc-[a-z]*-*)
   360             CT_TestAndAbort "Trying to extract the C-library addon/locales \"${file}\" when C-library not yet extracted" ! -d "${CT_LIBC_FILE}"
   361             cd "${CT_LIBC_FILE}"
   362             libc_addon=y
   363             [ -f ".${file}.extracted" ] && return 0
   364             touch ".${file}.extracted"
   365             ;;
   366         uClibc-locale-*)
   367             CT_TestAndAbort "Trying to extract the C-library addon/locales \"${file}\" when C-library not yet extracted" ! -d "${CT_LIBC_FILE}"
   368             cd "${CT_LIBC_FILE}/extra/locale"
   369             libc_addon=y
   370             [ -f ".${file}.extracted" ] && return 0
   371             touch ".${file}.extracted"
   372             ;;
   373     esac
   374 
   375     # If the directory exists, then consider extraction and patching done
   376     if [ -d "${file}" ]; then
   377         CT_DoLog DEBUG "Already extracted \"${file}\""
   378         return 0
   379     fi
   380 
   381     CT_DoLog EXTRA "Extracting \"${file}\""
   382     case "${ext}" in
   383         .tar.bz2)     tar xvjf "${full_file}" |CT_DoLog ALL;;
   384         .tar.gz|.tgz) tar xvzf "${full_file}" |CT_DoLog ALL;;
   385         .tar)         tar xvf  "${full_file}" |CT_DoLog ALL;;
   386         *)            CT_Abort "Don't know how to handle \"${file}\": unknown extension" ;;
   387     esac
   388 
   389     # Snapshots might not have the version number in the extracted directory
   390     # name. This is also the case for some (old) packages, such as libfloat.
   391     # Overcome this issue by symlink'ing the directory.
   392     if [ ! -d "${file}" -a "${libc_addon}" != "y" ]; then
   393         case "${ext}" in
   394             .tar.bz2)     base=`tar tjf "${full_file}" |head -n 1 |cut -d / -f 1 || true`;;
   395             .tar.gz|.tgz) base=`tar tzf "${full_file}" |head -n 1 |cut -d / -f 1 || true`;;
   396             .tar)         base=`tar tf  "${full_file}" |head -n 1 |cut -d / -f 1 || true`;;
   397         esac
   398         CT_TestOrAbort "There was a problem when extracting \"${file}\"" -d "${base}" -o "${base}" != "${file}"
   399         ln -s "${base}" "${file}"
   400     fi
   401 
   402     # Kludge: outside this function, we wouldn't know if we had just extracted
   403     # a libc addon, or a plain package. Apply patches now.
   404     CT_DoLog EXTRA "Patching \"${file}\""
   405 
   406     if [ "${libc_addon}" = "y" ]; then
   407         # Some addons tarball directly contian the correct addon directory,
   408         # while others have the addon directory named ofter the tarball.
   409         # Fix that bu always using the short name (eg: linuxthreads, ports, etc...)
   410         addon_short_name=`echo "${file}" |sed -r -e 's/^[^-]+-//; s/-[^-]+$//;'`
   411         [ -d "${addon_short_name}" ] || ln -s "${file}" "${addon_short_name}"
   412         # If libc addon, we're already in the correct place
   413     else
   414         cd "${file}"
   415     fi
   416 
   417     [ "${CUSTOM_PATCH_ONLY}" = "y" ] || official_patch_dir="${CT_TOP_DIR}/patches/${base_file}/${ver_file}"
   418     [ "${CT_CUSTOM_PATCH}" = "y" ] && custom_patch_dir="${CT_CUSTOM_PATCH_DIR}/${base_file}/${ver_file}"
   419     for patch_dir in "${official_patch_dir}" "${custom_patch_dir}"; do
   420         if [ -n "${patch_dir}" -a -d "${patch_dir}" ]; then
   421             for p in "${patch_dir}"/*.patch; do
   422                 if [ -f "${p}" ]; then
   423                     CT_DoLog DEBUG "Applying patch \"${p}\""
   424                     patch -g0 -F1 -p1 -f <"${p}" |CT_DoLog ALL
   425                     CT_TestAndAbort "Failed while applying patch file \"${p}\"" ${PIPESTATUS[0]} -ne 0
   426                 fi
   427             done
   428         fi
   429     done
   430 
   431     CT_Popd
   432 }
   433 
   434 # Compute the target triplet from what is provided by the user
   435 # Usage: CT_DoBuildTargetTriplet
   436 # In fact this function takes the environment variables to build the target
   437 # triplet. It is needed both by the normal build sequence, as well as the
   438 # sample saving sequence.
   439 CT_DoBuildTargetTriplet() {
   440     case "${CT_ARCH_BE},${CT_ARCH_LE}" in
   441         y,) target_endian_eb=eb; target_endian_el=;;
   442         ,y) target_endian_eb=; target_endian_el=el;;
   443     esac
   444     case "${CT_ARCH}" in
   445         arm)  CT_TARGET="${CT_ARCH}${target_endian_eb}";;
   446         mips) CT_TARGET="${CT_ARCH}${target_endian_el}";;
   447         x86*) # Much love for this one :-(
   448               arch="${CT_ARCH_ARCH}"
   449               [ -z "${arch}" ] && arch="${CT_ARCH_TUNE}"
   450               case "${CT_ARCH}" in
   451                   x86_64)  CT_TARGET=x86_64;;
   452               	  *)  case "${arch}" in
   453                           "")                                       CT_TARGET=i386;;
   454                           i386|i486|i586|i686)                      CT_TARGET="${arch}";;
   455                           winchip*)                                 CT_TARGET=i486;;
   456                           pentium|pentium-mmx|c3*)                  CT_TARGET=i586;;
   457                           nocona|athlon*64|k8|athlon-fx|opteron)    CT_TARGET=x86_64;;
   458                           pentiumpro|pentium*|athlon*)              CT_TARGET=i686;;
   459                           *)                                        CT_TARGET=i586;;
   460                       esac;;
   461               esac;;
   462     esac
   463     case "${CT_TARGET_VENDOR}" in
   464         "") CT_TARGET="${CT_TARGET}-unknown";;
   465         *)  CT_TARGET="${CT_TARGET}-${CT_TARGET_VENDOR}";;
   466     esac
   467     case "${CT_KERNEL}" in
   468         linux*)  CT_TARGET="${CT_TARGET}-linux";;
   469     esac
   470     case "${CT_LIBC}" in
   471         glibc)  CT_TARGET="${CT_TARGET}-gnu";;
   472         uClibc) CT_TARGET="${CT_TARGET}-uclibc";;
   473     esac
   474     CT_TARGET="`${CT_TOP_DIR}/tools/config.sub ${CT_TARGET}`"
   475 }
   476 
   477 # This function does pause the build until the user strikes "Return"
   478 # Usage: CT_DoPause [optional_message]
   479 CT_DoPause() {
   480     local foo
   481     local message="${1:-Pausing for your pleasure}"
   482     CT_DoLog INFO "${message}"
   483     read -p "Press \"Enter\" to continue, or Ctrl-C to stop..." foo >&6
   484     return 0
   485 }
   486 
   487 # This function saves the state of the toolchain to be able to restart
   488 # at any one point
   489 # Usage: CT_DoSaveState <next_step_name>
   490 CT_DoSaveState() {
   491 	[ "${CT_DEBUG_CT_SAVE_STEPS}" = "y" ] || return 0
   492     local state_name="$1"
   493     local state_dir="${CT_STATE_DIR}/${state_name}"
   494 
   495     CT_DoLog DEBUG "Saving state to restart at step \"${state_name}\"..."
   496     rm -rf "${state_dir}"
   497     mkdir -p "${state_dir}"
   498 
   499     case "${CT_DEBUG_CT_SAVE_STEPS_GZIP}" in
   500         y)  tar_opt=czf; tar_ext=".tar.gz";;
   501         *)  tar_opt=cf;  tar_ext=".tar";;
   502     esac
   503 
   504     CT_DoLog DEBUG "  Saving environment and aliases"
   505     # We must omit shell functions
   506     # 'isgrep' is here because I don't seem to
   507     # be able to remove the functions names.
   508     set |awk '
   509          BEGIN { _p = 1; }
   510          $0~/^[^ ] ()/ { _p = 0; }
   511          _p == 1
   512          $0 == "}" { _p = 1; }
   513          ' |egrep -v '^[^ ]+ \(\)' >"${state_dir}/env.sh"
   514 
   515     CT_DoLog DEBUG "  Saving CT_CC_CORE_STATIC_PREFIX_DIR=\"${CT_CC_CORE_STATIC_PREFIX_DIR}\""
   516     CT_Pushd "${CT_CC_CORE_STATIC_PREFIX_DIR}"
   517     tar ${tar_opt} "${state_dir}/cc_core_static_prefix_dir${tar_ext}" .
   518     CT_Popd
   519 
   520     CT_DoLog DEBUG "  Saving CT_CC_CORE_SHARED_PREFIX_DIR=\"${CT_CC_CORE_SHARED_PREFIX_DIR}\""
   521     CT_Pushd "${CT_CC_CORE_SHARED_PREFIX_DIR}"
   522     tar ${tar_opt} "${state_dir}/cc_core_shared_prefix_dir${tar_ext}" .
   523     CT_Popd
   524 
   525     CT_DoLog DEBUG "  Saving CT_PREFIX_DIR=\"${CT_PREFIX_DIR}\""
   526     CT_Pushd "${CT_PREFIX_DIR}"
   527     tar ${tar_opt} "${state_dir}/prefix_dir${tar_ext}" --exclude '*.log' .
   528     CT_Popd
   529 
   530     if [ "${CT_LOG_TO_FILE}" = "y" ]; then
   531         CT_DoLog DEBUG "  Saving log file"
   532         exec >/dev/null
   533         case "${CT_DEBUG_CT_SAVE_STEPS_GZIP}" in
   534             y)  gzip -3 -c "${CT_LOG_FILE}"  >"${state_dir}/log.gz";;
   535             *)  cat "${CT_LOG_FILE}" >"${state_dir}/log";;
   536         esac
   537         exec >>"${CT_LOG_FILE}"
   538     fi
   539 }
   540 
   541 # This function restores a previously saved state
   542 # Usage: CT_DoLoadState <state_name>
   543 CT_DoLoadState(){
   544     local state_name="$1"
   545     local state_dir="${CT_STATE_DIR}/${state_name}"
   546     local old_RESTART="${CT_RESTART}"
   547     local old_STOP="${CT_STOP}"
   548 
   549     CT_TestOrAbort "The previous build did not reach the point where it could be restarted at \"${CT_RESTART}\"" -d "${state_dir}"
   550 
   551     # We need to do something special with the log file!
   552     if [ "${CT_LOG_TO_FILE}" = "y" ]; then
   553         exec >"${state_dir}/tail.log"
   554     fi
   555     CT_DoLog INFO "Restoring state at step \"${state_name}\", as requested."
   556 
   557     case "${CT_DEBUG_CT_SAVE_STEPS_GZIP}" in
   558         y)  tar_opt=xzf; tar_ext=".tar.gz";;
   559         *)  tar_opt=cf;  tar_ext=".tar";;
   560     esac
   561 
   562     CT_DoLog DEBUG "  Removing previous build directories"
   563     chmod -R u+rwX "${CT_PREFIX_DIR}" "${CT_CC_CORE_SHARED_PREFIX_DIR}" "${CT_CC_CORE_STATIC_PREFIX_DIR}"
   564     rm -rf         "${CT_PREFIX_DIR}" "${CT_CC_CORE_SHARED_PREFIX_DIR}" "${CT_CC_CORE_STATIC_PREFIX_DIR}"
   565     mkdir -p       "${CT_PREFIX_DIR}" "${CT_CC_CORE_SHARED_PREFIX_DIR}" "${CT_CC_CORE_STATIC_PREFIX_DIR}"
   566 
   567     CT_DoLog DEBUG "  Restoring CT_PREFIX_DIR=\"${CT_PREFIX_DIR}\""
   568     CT_Pushd "${CT_PREFIX_DIR}"
   569     tar ${tar_opt} "${state_dir}/prefix_dir${tar_ext}"
   570     CT_Popd
   571 
   572     CT_DoLog DEBUG "  Restoring CT_CC_CORE_SHARED_PREFIX_DIR=\"${CT_CC_CORE_SHARED_PREFIX_DIR}\""
   573     CT_Pushd "${CT_CC_CORE_SHARED_PREFIX_DIR}"
   574     tar ${tar_opt} "${state_dir}/cc_core_shared_prefix_dir${tar_ext}"
   575     CT_Popd
   576 
   577     CT_DoLog DEBUG "  Restoring CT_CC_CORE_STATIC_PREFIX_DIR=\"${CT_CC_CORE_STATIC_PREFIX_DIR}\""
   578     CT_Pushd "${CT_CC_CORE_STATIC_PREFIX_DIR}"
   579     tar ${tar_opt} "${state_dir}/cc_core_static_prefix_dir${tar_ext}"
   580     CT_Popd
   581 
   582     # Restore the environment, discarding any error message
   583     # (for example, read-only bash internals)
   584     CT_DoLog DEBUG "  Restoring environment"
   585     . "${state_dir}/env.sh" >/dev/null 2>&1 || true
   586 
   587     # Restore the new RESTART and STOP steps
   588     CT_RESTART="${old_RESTART}"
   589     CT_STOP="${old_STOP}"
   590     unset old_stop old_restart
   591 
   592     if [ "${CT_LOG_TO_FILE}" = "y" ]; then
   593         CT_DoLog DEBUG "  Restoring log file"
   594         exec >/dev/null
   595         case "${CT_DEBUG_CT_SAVE_STEPS_GZIP}" in
   596             y)  zcat "${state_dir}/log.gz" >"${CT_LOG_FILE}";;
   597             *)  cat "${state_dir}/log" >"${CT_LOG_FILE}";;
   598         esac
   599         cat "${state_dir}/tail.log" >>"${CT_LOG_FILE}"
   600         exec >>"${CT_LOG_FILE}"
   601         rm -f "${state_dir}/tail.log"
   602     fi
   603 }